
#import <collections.h>
#import "BatchSwarm.h"
#import "ModelSwarm.h"

@implementation BatchSwarm

//-getParameters { return parameters; }


+createBegin: (id) aZone {
  BatchSwarm *obj;

  obj = [super createBegin: aZone];
  //  obj->parameters = [Parameters createBegin: globalZone];

  return obj;
}

-buildObjectsArgC: (int) argc ArgV: (char **) argv {
  id modelZone;

  [super buildObjects];

  //  [parameters initParameters];
  //[parameters processCmdLineArgC: argc ArgV: (const char**) argv];

  modelZone = [Zone create: [self getZone]];
  modelSwarm = [ModelSwarm create: modelZone];
  //[modelSwarm setParameters: parameters];

  [modelSwarm buildObjects];

  return self;
}  

-buildActions {
  [super buildActions];
  
  [modelSwarm buildActions];
  
  displayActions = [ActionGroup create: [self getZone]];

  displaySchedule = [Schedule createBegin: [self getZone]];
  [displaySchedule setRepeatInterval: 1];
  displaySchedule = [displaySchedule createEnd];
  [displaySchedule at: 0 createAction: displayActions];

  stopSchedule = [Schedule create: [self getZone]];
  [stopSchedule at: RetUPar("stopT") createActionTo: self 
         message: M(stopRunning)];
  
  return self;
}  

-activateIn: (id) swarmContext {
  [super activateIn: swarmContext];

  [modelSwarm activateIn: self];

  [stopSchedule activateIn: self];
  [displaySchedule activateIn: self];

  return [self getSwarmActivity];
}

-go {
  [[self getActivity] run];
  return [[self getActivity] getStatus];
}

-stopRunning {
  [getTopLevelActivity() terminate]; // Terminate the simulation.
  return self;
}

@end
